/**
 * Created by root on 21.03.14.
 */
var events = require("events");


var utils = {};
module.exports = utils;

utils.releaseMode = false;
utils.oo = function () {

    var extend = function (target, source) {
        source = new source();
        for (var property in source) {
            //if(source.hasOwnProperty(property))
            if (!target.hasOwnProperty(property))
                target[property] = source[property];
        }
        target.super = source;
    };
    var implement = function (target, source) {
        source = new source();
        if (!utils.releaseMode) {
            for (var property in source) {
                if (source.hasOwnProperty(property))
                    if (!target.hasOwnProperty(property))
                        throw new Error(property + " property not implemented");
            }
        }


        return target;
    };
    var Class = function (ancestor, interfaces, constructor) {
        return function () {
            extend(this, constructor);

            if (!Array.isArray(interfaces)) interfaces = [interfaces];

            if (ancestor)
                extend(this, ancestor);


            if (interfaces[0])
                for (i = 0; i < interfaces.length; i++) {
                    implement(this, interfaces[i]);
                }
        };
    };
    return{
        Class: Class,
        extend: extend,
        implement: implement
    }
}();
utils.pattern = function () {
    var Subject = function () {
        this.subscribers = [];
    };
    Subject.prototype.notify = function (event) {
        var i = this.subscribers.length;
        while (i-- > 0) {
            this.subscribers[i].update(this, event);
        }
    };
    Subject.prototype.subscribe = function (obj) {
        if (this.subscribers.indexOf(obj) == -1)this.subscribers.push(obj);
    };
    Subject.prototype.unsubscribe = function (obj) {
        this.subscribers.splice(this.subscribers.indexOf(obj), 1);
    };

    var IObserver = function () {
        this.update = function (subject, changed) {
        };
    };

    var Singleton = function (ancestor, interfaces, constructor) {
        var con = function () {
            if (con.instance) throw new Error("Double instance of singleton");
            con.instance = this;
            utils.oo.extend(this, constructor);

            if (!Array.isArray(interfaces)) interfaces = [interfaces];

            if (ancestor)
                utils.oo.extend(this, ancestor);

            if (interfaces[0])
                for (i = 0; i < interfaces.length; i++) {
                    utils.oo.implement(this, interfaces[i]);
                }
        };
        return con;
    };

    return {
        Subject: Subject,
        IObserver: IObserver,
        Singleton: Singleton
    }
}();
utils.test = function (func, times) {
    var time = Date.now();
    for (var i = 0; i < times; i++) {
        func();
    }
    return Date.now() - time;
};
utils.decorate = function (decorators, func)
{
    var f = func;
    for( var i = 0 ; i < decorators.length; i++)
    {
        f = decorators[i](f)
    }
    return f;
};